<?php
/*
 *
 * @Version       $Id: jaudit.php 1978 2015-03-09 16:57:22Z geoffc $
 * @Package       Macrotone Joomla Audit
 * @Subpackage    com_jaudit
 * @Release       1.0.3
 * @Copyright     Copyright (C) 2012-2015 Macrotone Consulting Ltd. All rights reserved.
 * @License       GNU General Public License version 3 or later; see LICENSE.txt
 * @Contact       support@macrotoneconsulting.co.uk
 * @Lastrevision  $Date: 2015-03-09 16:57:22 +0000 (Mon, 09 Mar 2015) $
 *
 */

// No direct access
defined('_JEXEC') or die;

/**
 * Jaudit helper.
 */
class JauditHelper
{

   protected static $change_table = 'jaudit_chistory';
   protected static $trig_ident = '_jaudit_';

   /**
    * Configure the Linkbar.
    * @param string $vName
    */
   public static function addSubmenu($vName = '')
   {
      $jversion = new JVersion();
      if( version_compare( $jversion->getShortVersion(), '3.1', 'ge' ) )
      {
         JHtmlSidebar::addEntry(
            JText::_('COM_JAUDIT_TITLE_CPANEL'),
            'index.php?option=com_jaudit',
            $vName == 'cpanel'
         );
         JHtmlSidebar::addEntry(
            JText::_('COM_JAUDIT_TITLE_JCHANGES'),
            'index.php?option=com_jaudit&view=jchanges',
            $vName == 'jchanges'
         );

         JHtmlSidebar::addEntry(
            JText::_('COM_JAUDIT_TITLE_JTRIGGERS'),
            'index.php?option=com_jaudit&view=jtriggers',
            $vName == 'jtriggers'
         );
         JHtmlSidebar::addEntry(
            JText::_('COM_JAUDIT_DISPLAY_LOG'),
            'index.php?option=com_jaudit&view=jauditlog',
            $vName == 'jauditlog'
         );
         JHtmlSidebar::addEntry(
            JText::_('COM_JAUDIT_TITLE_DOCUMENTATION'),
            'index.php?option=com_jaudit&view=documentation',
            $vName == 'documentation'
         );
         JHtmlSidebar::addEntry(
            JText::_('COM_JAUDIT_TITLE_SUPPORT'),
            'index.php?option=com_jaudit&view=support',
            $vName == 'support'
         );
      } else {
         JSubMenuHelper::addEntry(
            JText::_('COM_JAUDIT_TITLE_CPANEL'),
            'index.php?option=com_jaudit',
            $vName == 'cpanel'
         );
         JSubMenuHelper::addEntry(
            JText::_('COM_JAUDIT_TITLE_JCHANGES'),
            'index.php?option=com_jaudit&view=jchanges',
            $vName == 'jchanges'
         );

         JSubMenuHelper::addEntry(
            JText::_('COM_JAUDIT_TITLE_JTRIGGERS'),
            'index.php?option=com_jaudit&view=jtriggers',
            $vName == 'jtriggers'
         );
         JSubMenuHelper::addEntry(
            JText::_('COM_JAUDIT_TITLE_DOCUMENTATION'),
            'index.php?option=com_jaudit&view=documentation',
            $vName == 'documentation'
         );
         JSubMenuHelper::addEntry(
            JText::_('COM_JAUDIT_TITLE_SUPPORT'),
            'index.php?option=com_jaudit&view=support',
            $vName == 'support'
         );
      }
   }

   /**
    * Gets a list of the actions that can be performed.
    *
    * @return  JObject
    * @since   1.6
    */
   public static function getActions()
   {
      $user = JFactory::getUser();
      $result  = new JObject;

      $assetName = 'com_jaudit';

      $actions = array(
         'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
      );

      foreach ($actions as $action) {
         $result->set($action, $user->authorise($action, $assetName));
      }

      return $result;
   }

    /**
     * Gets a list of the tables being monitored.
     *
     * @param int $inchead
     * @return  JObject
     * @since   1.6
     */
   public static function getTablename( $inchead = 0 )
   {
      $db = JFactory::getDBO();
      $db->setQuery( 'SELECT distinct `table_name` AS value, `table_name` AS text FROM `#__jaudit_chistory` ORDER BY table_name');
      $options = array();
      // Add an optional null value line if requested
      if ( $inchead == 0 ) {
         $options[] = JHTML::_('select.option', '', '- '.JText::_('COM_JAUDIT_SELECT_TABLE').' -' );
      }

      foreach( $db->loadObjectList() as $r){
         $options[] = JHTML::_('select.option',  $r->value, $r->text );
      }
      return $options;
   }

    /**
     * Gets a list of the tables being monitored.
     *
     * @param int $inchead
     * @return  JObject
     * @since   1.6
     */
   public static function getTrig_tablename( $inchead = 0 )
   {
      $db = JFactory::getDBO();
      $db->setQuery( 'SELECT distinct `table_name` AS value, `table_name` AS text FROM `#__jaudit_triggers` ORDER BY table_name');
      $options = array();
      // Add an optional null value line if requested
      if ( $inchead == 0 ) {
         $options[] = JHTML::_('select.option', '', '- '.JText::_('COM_JAUDIT_SELECT_TABLE').' -' );
      }

      foreach( $db->loadObjectList() as $r){
         $options[] = JHTML::_('select.option',  $r->value, $r->text );
      }
      return $options;
   }

    /**
     * Gets a list of the components being monitored.
     *
     * @param int $inchead
     * @return  JObject
     * @since   1.6
     */
   public static function getComponentname( $inchead = 0 )
      {
         $db = JFactory::getDBO();
         $db->setQuery( 'SELECT distinct `component` AS value, `component` AS text FROM `#__jaudit_chistory` ORDER BY component');
         $options = array();
         // Add an optional null value line if requested
         if ( $inchead == 0 ) {
            $options[] = JHTML::_('select.option', '', '- '.JText::_('COM_JAUDIT_SELECT_COMPONENT').' -' );
         }

         foreach( $db->loadObjectList() as $r){
            $options[] = JHTML::_('select.option',  $r->value, $r->text );
         }
         return $options;
   }

   /*
    * Given the input data create and audit trigger based on criteria.
    *
    */
   static function createAuditTrigger( & $data )
   {
      // echo "<PRE>";var_dump($data);echo "</PRE>";
      $app = JFactory::getApplication();

      // Set up access to default parameters
      // $params     = JComponentHelper::getParams( 'com_jaudit' );
      // $ftranslate = $params->get('ftranslate', 0);

      $events = array('INSERT','UPDATE','DELETE');
      $types   = array('BEFORE','AFTER');

      $tname = $data['table_name'];

      if ( empty($tname) )  {
         $app->enqueuemessage(JText::_('COM_JAUDIT_NO_TABLENAME SPECIFIED'), 'error');
         return false;   //Shouldn't occur.
      }

      $event = $data['trigger_event'];
      if ( !in_array( $event, $events) ) {
         $app->enqueuemessage(JText::_('COM_JAUDIT_INVALID_TRIG_EVENT_TEXT'), 'error');
         return false;
      }

      $type = $data['trigger_type'];
      if ( !in_array( $type, $types) ) {
         $app->enqueuemessage(JText::_('COM_JAUDIT_INVALID_TRIG_TYPE_TEXT'), 'error');
         return false;
      }

      if ( empty($db) ) $db = JFactory::getDbo();

      // Create database trigger.
      $trig = $tname.self::$trig_ident;
      if ( $type == 'BEFORE' ) {
         switch ($event) {
            case 'INSERT':
               $trig .= "bi";
               break;
            case 'UPDATE':
               $trig .= "bu";
               break;
            case 'DELETE':
               $trig .= "bd";
               break;
         }
      } else {
         switch ($event){
            case 'INSERT':
               $trig .= "ai";
               break;
            case 'UPDATE':
               $trig .= "au";
               break;
            case 'DELETE':
               $trig .= "ad";
               break;
         }
      }

      // Now update the trigger name.
      $data['trigger_name'] = $trig;

      // Check if we have a trigger already in our table of this name.
      // $db = JFactory::getDBO();
      $db->setQuery("SELECT count(*) FROM `#__jaudit_triggers` WHERE trigger_name = '".$trig."'");
      $res = $db->loadResult();

      if ( ($data['id'] == 0 && $res >= 1 ) || $res > 2 ) {
         return false;
      }

      // Determine component as well as we can.
      $pos1 = strpos($tname, '_') + 1;
      $pos2 = strpos($tname, '_', $pos1);
      if ( empty($pos2)) {
         $compnt = substr($tname, $pos1);
      } else {
         $compnt = substr($tname, $pos1, $pos2-$pos1);
      }

      $trigstr ="CREATE TRIGGER `".$trig."`";
      $trigstr.= "\n ".$type." ".$event." ON `".$tname."`";
      $trigstr.= "\n FOR EACH ROW";
      $trigstr.= "\n BEGIN ";

      // Get the first super user id as a default for the changedby column.
      $susers = JAccess::getUsersByGroup(8);
      if ( !empty($susers) ) {
          $superid = $susers[0];
      } else {
         // Give warning if not found.
         $app = JFactory::getApplication();
         $app->enqueueMessage(JText::_('COM_JAUDIT_NO_SUPERUSER_DETERMINED'), 'warning');
         $superid = 0;
      }

      $cols = json_decode($data['columns']);
      // For each of the values specified in the columns array set up the comparison statement.
      // Get the field type from the database
      switch ($event) {
         case "INSERT":
            $trigstr.= "\n   DECLARE nval VARCHAR(255);";
            $trigstr.= "\n   DECLARE changedby VARCHAR(12);";
            $trigstr.= "\n   DECLARE component VARCHAR(255) DEFAULT '".$compnt."';";
            $trigstr.= "\n   DECLARE cexists BOOLEAN;";
            $trigstr.= "\n   DECLARE superid INT DEFAULT ".$superid.";";
            $trigstr.= "\n   DECLARE changeid INT;";
            $trigstr.= "\n   DECLARE chkint INT;";

            $text = self::create_insert_text($tname, $cols);
            $trigstr .= $text;
            break;

         case "UPDATE";
            $trigstr.= "\n   DECLARE nval VARCHAR(255);";
            $trigstr.= "\n   DECLARE oval VARCHAR(255);";
            $trigstr.= "\n   DECLARE changedby VARCHAR(12);";
            $trigstr.= "\n   DECLARE component VARCHAR(255) DEFAULT '".$compnt."';";
            $trigstr.= "\n   DECLARE cexists BOOLEAN;";
            $trigstr.= "\n   DECLARE superid INT DEFAULT ".$superid.";";
            $trigstr.= "\n   DECLARE changeid INT;";
            $trigstr.= "\n   DECLARE chkint INT;";

            $text = self::create_update_text($tname, $cols);
            $trigstr .= $text;
            break;

         case "DELETE":
            $trigstr.= "\n   DECLARE oval VARCHAR(255);";
            $trigstr.= "\n   DECLARE changedby VARCHAR(12);";
            $trigstr.= "\n   DECLARE component VARCHAR(255) DEFAULT '".$compnt."';";
            $trigstr.= "\n   DECLARE cexists BOOLEAN;";
            $trigstr.= "\n   DECLARE superid INT DEFAULT ".$superid.";";
            $trigstr.= "\n   DECLARE changeid INT;";
            $trigstr.= "\n   DECLARE chkint INT;";

            $text = self::create_delete_text($tname, $cols);
            $trigstr .= $text;
            break;
         }

      $trigstr.= "\nEND;";

      $data['trigger_text'] = $trigstr;
      return true;
   }

   static function create_insert_text($tname, $cols)
   {
      // Set up access to default parameters
      $params     = JComponentHelper::getParams( 'com_jaudit' );
      $ftranslate = $params->get('ftranslate', 0);

      $db = JFactory::getDBO();
      $prefix = $db->getPrefix();
      $ctable = $db->getPrefix().self::$change_table;

      $str = null;

      $db->setQuery("select COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE  TABLE_NAME = '".$tname."' AND COLUMN_KEY = 'PRI' ");
      $pkeycol = $db->loadResult();

      // Check whether we have the modified_by field.
      $query = "SELECT IF(count(*) >0 , TRUE, FALSE)";
      $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
      $query.= " WHERE TABLE_NAME  = '".$tname."' ";
      $query.= " AND COLUMN_NAME = 'created_by'";
      $query.= " AND DATA_TYPE IN ('int','bigint')";
      $db->setQuery($query);
      $res = $db->loadResult();

      // Set up the changedby column default.
      $str.= "\n SELECT superid INTO changedby; ";

      if ( $res) {
         $str.= "\n  SELECT IFNULL(created_by, 0) INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = NEW.".$pkeycol."; ";
         $str.= "\n  SELECT CAST(changedby AS UNSIGNED) INTO chkint; ";
         $str.= "\n  IF ( chkint ) THEN ";
         $str.= "\n     SELECT chkint INTO changedby; ";
         $str.= "\n  END IF;";
      } else {
         // Additional check just in case the created_by field is a varchar.
         $query= "SELECT IF(count(*) >0 , TRUE, FALSE)";
         $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
         $query.= " WHERE TABLE_NAME  = '".$tname."' ";
         $query.= " AND COLUMN_NAME = 'created_by'";
         $query.= " AND DATA_TYPE IN ('varchar')";
         $db->setQuery($query);
         $resv = $db->loadResult();

         if ( $resv) {
            $str.= "\n  SELECT created_by INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = NEW.".$pkeycol."; ";
            $str.= "\n  IF  EXISTS (SELECT ID INTO changeid FROM `#__users` WHERE USERNAME = changedby) THEN ";
            $str.= "\n     SELECT changeid INTO changedby; ";
            $str.= "\n  END IF;";
         }
      }

      // Check for an alias field for key link field.
      $db->setQuery("SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like '".$tname."' AND COLUMN_NAME = 'alias' ");
      $res = $db->loadResult();

      if ( ! empty($res) ) {
         $aliascol = 'alias';
      } else {
         $aliascol = $pkeycol;
      }

      // A convoluted test but have to allow for J2.5 and J3 which return different possible results.
      if (  $cols[0] == '(array) All' || $cols == '(array) All' || $cols == 'All' || empty($cols[0]) || empty($cols) || in_array('All', $cols) ) {
         $db->setQuery("SELECT COLUMN_NAME, DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like '".$tname."' ");
         $res = $db->loadObjectList();

         foreach($res as $row) {
            $col = $row->COLUMN_NAME;
            $str.= "\n  IF (NEW.".$col." IS NOT NULL) THEN";

            if ( $ftranslate ) {
               $statement = 0;
               if ( $col == 'state' ) {
                  $statement = 1;
                  $str .= self::trans_state('I');
               }
               if ( $col == 'checked_out' || ( $col == 'created_by' && $row->DATA_TYPE == 'int' ) || ($col == 'modified_by' && $row->DATA_TYPE == 'int') ) {
                  $statement = 1;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into nval FROM `".$prefix."users` WHERE NEW.".$col." != 0 AND id = NEW.".$col.";" ;
               }

               if ( $statement == 1 ) {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, new_value, action, row_key, row_key_link, change_by)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, nval, 'INSERT', NEW.".$pkeycol.", NEW.".$aliascol.", changedby);";
               } else {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, new_value, action, row_key, row_key_link, change_by)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, NEW.".$col.", 'INSERT', NEW.".$pkeycol.", NEW.".$aliascol.", changedby);";
               }
            } else {
               $str.= "\n     INSERT INTO ".$ctable;
               $str.= "\n        (table_name, column_name, column_type, component, new_value, action, row_key, row_key_link, change_by)";
               $str.= "\n     VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, NEW.".$col.", 'INSERT', NEW.".$pkeycol.", NEW.".$aliascol.", changedby);";
            }
            $str.= "\n   END IF;";
         }
      } else {
         foreach($cols as $col) {
            $db->setQuery("SELECT DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like '".$tname."' AND COLUMN_NAME = '".$col."' ");
            $ctype = $db->loadResult();
            $str.= "\n  IF (NEW.".$col." IS NOT NULL) THEN";

            if ( $ftranslate ) {
               $statement = 0;
               if ( $col == 'state' ) {
                  $statement = 1;
                  $str .= self::trans_state('I');
               }
               if ( $col == 'checked_out' || ( $col == 'created_by' && $ctype == 'int' ) || ($col == 'modified_by' && $ctype == 'int') ) {
                  $statement = 1;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into nval FROM `".$prefix."users` WHERE NEW.".$col." != 0 AND id = NEW.".$col.";" ;
               }

               if ( $statement == 1 ) {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, new_value, action, row_key, row_key_link, change_by)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$ctype."', component, nval, 'INSERT', NEW.".$pkeycol.", NEW.".$aliascol.", changedby);";
               } else {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, new_value, action, row_key, row_key_link, change_by)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$ctype."', component, NEW.".$col.", 'INSERT', NEW.".$pkeycol.", NEW.".$aliascol.", changedby);";
               }
            } else {
               $str.= "\n     INSERT INTO ".$ctable;
               $str.= "\n        (table_name, column_name, column_type, component, new_value, action, row_key, row_key_link, change_by)";
               $str.= "\n     VALUES ('".$tname."', '".$col."', '".$ctype."', component, NEW.".$col.", 'INSERT', NEW.".$pkeycol.", NEW.".$aliascol.", changedby);";
            }
            $str.= "\n   END IF;";
         }
      }
      return $str;
   }

   static function create_update_text($tname, $cols)
   {
      // Set up access to default parameters
      $params     = JComponentHelper::getParams( 'com_jaudit' );
      $ftranslate = $params->get('ftranslate', 0);

      $db = JFactory::getDBO();
      $prefix = $db->getPrefix();
      $ctable = $prefix . self::$change_table;
      // echo "<PRE>"; var_dump($cols); echo "</PRE>";
      $str = null;

      $db->setQuery("select COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = '".$tname."' AND COLUMN_KEY = 'PRI' ");
      $pkeycol = $db->loadResult();

      // Check whether we have the modified_by field.
      $query = "SELECT IF(count(*) >0 , TRUE, FALSE)";
      $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
      $query.= " WHERE TABLE_NAME  = '".$tname."' ";
      $query.= " AND COLUMN_NAME = 'modified_by'";
      $query.= " AND DATA_TYPE IN ('int','bigint')";
      $db->setQuery($query);
      $res = $db->loadResult();

      // Set up the changedby column default.
      $str.= "\n SELECT superid INTO changedby; ";

      if ( $res) {
         $str.= "\n  SELECT IFNULL(modified_by, 0) INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = NEW.".$pkeycol."; ";
         $str.= "\n  SELECT CAST(changedby AS UNSIGNED) INTO chkint; ";
         $str.= "\n  IF ( chkint ) THEN ";
         $str.= "\n     SELECT chkint INTO changedby; ";
         $str.= "\n  END IF;";
      } else {
         // Additional check just in case the modified_by field is a varchar.
         $query= "SELECT IF(count(*) >0 , TRUE, FALSE)";
         $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
         $query.= " WHERE TABLE_NAME  = '".$tname."' ";
         $query.= " AND COLUMN_NAME = 'modified_by'";
         $query.= " AND DATA_TYPE IN ('varchar')";
         $db->setQuery($query);
         $resv = $db->loadResult();

         if ( $resv) {
            $str.= "\n  SELECT modified_by INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = NEW.".$pkeycol."; ";
            $str.= "\n  IF  EXISTS (SELECT ID INTO changeid FROM `#__users` WHERE USERNAME = changedby) THEN ";
            $str.= "\n     SELECT changeid INTO changedby; ";
            $str.= "\n  END IF;";
         }
      }

      // Check for an alias field for key link field.
      $db->setQuery("SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like '".$tname."' AND COLUMN_NAME = 'alias' ");
      $res = $db->loadResult();

      if ( ! empty($res) ) {
         $aliascol = 'alias';
      } else {
         $aliascol = $pkeycol;
      }

      if (  $cols[0] == '(array) All' || $cols == '(array) All' || $cols == 'All' || empty($cols[0]) || empty($cols) || in_array('All', $cols) ) {
         $db = JFactory::getDBO();
         $db->setQuery("SELECT COLUMN_NAME, DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name like '".$tname."' ");
         $res = $db->loadObjectList();

         foreach($res as $row) {
            $col = $row->COLUMN_NAME;
            $str.= "\n  IF (OLD.".$col." IS NULL AND NEW.".$col." IS NOT NULL) OR";
            $str.= "\n     (OLD.".$col." IS NOT NULL AND NEW.".$col." IS NULL) OR";
            $str.= "\n     (OLD.".$col." != NEW.".$col.") THEN";

            if ( $ftranslate ) {
               $statement = 0;
               if ( $col == 'state' ) {
                  $statement = 1;
                  $str .= self::trans_state('U');
               }
               if ( $col == 'checked_out' || ( $col == 'created_by' && $row->DATA_TYPE == 'int' ) || ($col == 'modified_by' && $row->DATA_TYPE == 'int') ) {
                  $statement = 1;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into oval FROM `".$prefix."users` WHERE OLD.".$col." != 0 AND id = OLD.".$col.";" ;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into nval FROM `".$prefix."users` WHERE NEW.".$col." != 0 AND id = NEW.".$col.";" ;
               }

               if ( $statement == 1 ) {
                  $str.= "\n   INSERT INTO ".$ctable;
                  $str.= "\n     (table_name, column_name, column_type, component, old_value, new_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n   VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, oval, nval, 'UPDATE', NEW.".$pkeycol.", NEW.".$aliascol.", changedby, NOW());";
               } else {
                  $str.= "\n  INSERT INTO ".$ctable;
                  $str.= "\n     (table_name, column_name, column_type, component, old_value, new_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n  VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, OLD.".$col.", NEW.".$col.", 'UPDATE', NEW.".$pkeycol.", NEW.".$aliascol.", changedby, NOW());";
               }
            } else {
               $str.= "\n  INSERT INTO ".$ctable;
               $str.= "\n     (table_name, column_name, column_type, component, old_value, new_value, action, row_key, row_key_link, change_by, change_date)";
               $str.= "\n  VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, OLD.".$col.", NEW.".$col.", 'UPDATE', NEW.".$pkeycol.", NEW.".$aliascol.", changedby, NOW());";
            }
            $str.= "\n  END IF;";
         }
      } else {
         foreach($cols as $col) {
            $db->setQuery("SELECT DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like '".$tname."'  AND COLUMN_NAME = '".$col."' ");
            $ctype = $db->loadResult();

            $str.= "\n   IF (OLD.".$col." IS NULL AND NEW.".$col." IS NOT NULL) OR";
            $str.= "\n      (OLD.".$col." IS NOT NULL AND NEW.".$col." IS NULL) OR";
            $str.= "\n      (OLD.".$col." != NEW.".$col.") THEN";

            if ( $ftranslate ) {
               $statement = 0;
               if ( $col == 'state' ) {
                  $statement = 1;
                  $str .= self::trans_state('U');
               }
               if ( $col == 'checked_out' || ( $col == 'created_by' && $ctype == 'int' ) || ($col == 'modified_by' && $ctype == 'int') ) {
                  $statement = 1;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into oval FROM `".$prefix."users` WHERE OLD.".$col." != 0 AND id = OLD.".$col.";" ;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into nval FROM `".$prefix."users` WHERE NEW.".$col." != 0 AND id = NEW.".$col.";" ;
               }

               if ( $statement == 1 ) {
                  $str.= "\n   INSERT INTO ".$ctable;
                  $str.= "\n     (table_name, column_name, column_type, component, old_value, new_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n   VALUES ('".$tname."', '".$col."', '".$ctype."', component, oval, nval, 'UPDATE', NEW.".$pkeycol.", NEW.".$aliascol.", changedby, NOW());";
               } else {
                  $str.= "\n  INSERT INTO ".$ctable;
                  $str.= "\n     (table_name, column_name, column_type, component, old_value, new_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n  VALUES ('".$tname."', '".$col."', '".$ctype."', component, OLD.".$col.", NEW.".$col.", 'UPDATE', NEW.".$pkeycol.", NEW.".$aliascol.", changedby, NOW());";
               }
            } else {
               $str.= "\n   INSERT INTO ".$ctable;
               $str.= "\n      (table_name, column_name, column_type, component, old_value, new_value, action, row_key, row_key_link, change_by, change_date)";
               $str.= "\n   VALUES ('".$tname."', '".$col."', '".$ctype."', component, OLD.".$col.", NEW.".$col.", 'UPDATE', NEW.".$pkeycol.", NEW.".$aliascol.", changedby, NOW());";
            }
            $str.= "\n   END IF;";
         }
      }
      return $str;
   }

   static function create_delete_text($tname, $cols)
   {
      // Set up access to default parameters
      $params     = JComponentHelper::getParams( 'com_jaudit' );
      $ftranslate = $params->get('ftranslate', 0);

      $db = JFactory::getDBO();
      $prefix = $db->getPrefix();
      $ctable = $db->getPrefix().self::$change_table;
      // echo "<PRE>"; var_dump($cols); echo "</PRE>";
      $str = null;

      $db->setQuery("select COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = '".$tname."' AND COLUMN_KEY = 'PRI' ");
      $pkeycol = $db->loadResult();

      // Check whether we have the modified_by field.
      $query = "SELECT IF(count(*) >0 , TRUE, FALSE)";
      $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
      $query.= " WHERE TABLE_NAME  = '".$tname."' ";
      $query.= " AND COLUMN_NAME = 'modified_by'";
      $query.= " AND DATA_TYPE IN ('int','bigint')";
      $db->setQuery($query);
      $res = $db->loadResult();

      // Set up the changedby column default.
      $str.= "\n SELECT superid INTO changedby; ";
      $resv = 0;

      if ( $res) {
         $str.= "\n  SELECT IFNULL(modified_by, 0) INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = OLD.".$pkeycol."; ";
         $str.= "\n  SELECT CAST(changedby AS UNSIGNED) INTO chkint; ";
         $str.= "\n  IF ( chkint ) THEN ";
         $str.= "\n     SELECT chkint INTO changedby; ";
         $str.= "\n  END IF;";
      } else {
         // Additional check just in case the modified_by field is a varchar.
         $query= "SELECT IF(count(*) >0 , TRUE, FALSE)";
         $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
         $query.= " WHERE TABLE_NAME  = '".$tname."' ";
         $query.= " AND COLUMN_NAME = 'modified_by'";
         $query.= " AND DATA_TYPE IN ('varchar')";
         $db->setQuery($query);
         $resv = $db->loadResult();

         if ( $resv) {
            $str.= "\n  SELECT modified_by INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = OLD.".$pkeycol."; ";
            $str.= "\n  IF  EXISTS (SELECT ID INTO changeid FROM `#__users` WHERE USERNAME = changedby) THEN ";
            $str.= "\n     SELECT changeid INTO changedby; ";
            $str.= "\n  END IF;";
         }
      }

      // If we did not have a modified_by field perhaps we had a created_by field.
      if ( $res == 0 && $resv == 0) {
         $query = "SELECT IF(count(*) >0 , TRUE, FALSE)";
         $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
         $query.= " WHERE TABLE_NAME  = '".$tname."' ";
         $query.= " AND COLUMN_NAME = 'created_by'";
         $query.= " AND DATA_TYPE IN ('int','bigint')";
         $db->setQuery($query);
         $res = $db->loadResult();

         if ( $res) {
            $str.= "\n  SELECT IFNULL(created_by, 0) INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = OLD.".$pkeycol."; ";
            $str.= "\n  SELECT CAST(changedby AS UNSIGNED) INTO chkint; ";
            $str.= "\n  IF ( chkint ) THEN ";
            $str.= "\n     SELECT chkint INTO changedby; ";
            $str.= "\n  END IF;";
         } else {
            // Additional check just in case the created_by field is a varchar.
            $query= "SELECT IF(count(*) >0 , TRUE, FALSE)";
            $query.= " FROM INFORMATION_SCHEMA.COLUMNS ";
            $query.= " WHERE TABLE_NAME  = '".$tname."' ";
            $query.= " AND COLUMN_NAME = 'created_by'";
            $query.= " AND DATA_TYPE IN ('varchar')";
            $db->setQuery($query);
            $resv = $db->loadResult();

            if ( $resv) {
               $str.= "\n  SELECT created_by INTO changedby FROM `".$tname."` WHERE ".$pkeycol." = OLD.".$pkeycol."; ";
               $str.= "\n  IF  EXISTS (SELECT ID INTO changeid FROM `#__users` WHERE USERNAME = changedby) THEN ";
               $str.= "\n     SELECT changeid INTO changedby; ";
               $str.= "\n  END IF;";
            }
         }
      }

      // TODO Really should get current user from session but we are in the DB so how?
      // Look in #__session table to see if we can work it out and relate
      // the db session with the originating Joomla connection.

      // Check for an alias field for key link field.
      $db->setQuery("SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like '".$tname."' AND COLUMN_NAME = 'alias' ");
      $res = $db->loadResult();

      if ( ! empty($res) ) {
         $aliascol = 'alias';
      } else {
         $aliascol = $pkeycol;
      }

      if (  $cols[0] == '(array) All' || $cols == '(array) All' || $cols == 'All' || empty($cols[0]) || empty($cols) || in_array('All', $cols) ) {
         $db = JFactory::getDBO();
         $db->setQuery("SELECT COLUMN_NAME, DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name like '".$tname."' ");
         $res = $db->loadObjectList();

         foreach($res as $row) {
            $col = $row->COLUMN_NAME;
            $str.= "\n  IF (OLD.".$col." IS NOT NULL) THEN";

           if ( $ftranslate ) {
               $statement = 0;
               if ( $col == 'state' ) {
                  $statement = 1;
                  $str .= self::trans_state('D');
               }
               if ( $col == 'checked_out' || ( $col == 'created_by' && $row->DATA_TYPE == 'int' ) || ($col == 'modified_by' && $row->DATA_TYPE == 'int') ) {
                  $statement = 1;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into oval FROM `".$prefix."users` WHERE OLD.".$col." != 0 AND id = OLD.".$col.";" ;
               }

               if ( $statement == 1 ) {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, old_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, oval, 'DELETE', OLD.".$pkeycol.", OLD.".$aliascol.", changedby, NOW());";
               } else {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, old_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, OLD.".$col.", 'DELETE', OLD.".$pkeycol.", OLD.".$aliascol.", changedby, NOW());";
               }
            } else {
               $str.= "\n     INSERT INTO ".$ctable;
               $str.= "\n        (table_name, column_name, column_type, component, old_value, action, row_key, row_key_link, change_by, change_date)";
               $str.= "\n     VALUES ('".$tname."', '".$col."', '".$row->DATA_TYPE."', component, OLD.".$col.", 'DELETE', OLD.".$pkeycol.", OLD.".$aliascol.", changedby, NOW());";
            }
            $str.= "\n   END IF;";
         }
      } else {
         foreach($cols as $col) {
            $db->setQuery("SELECT DATA_TYPE FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like '".$tname."'  AND COLUMN_NAME = '".$col."' ");
            $ctype = $db->loadResult();

            $str.= "\n  IF (OLD.".$col." IS NOT NULL) THEN";
            if ( $ftranslate ) {
               $statement = 0;
               if ( $col == 'state' ) {
                  $statement = 1;
                  $str .= self::trans_state('D');
               }
               if ( $col == 'checked_out' || ( $col == 'created_by' && $ctype == 'int' ) || ($col == 'modified_by' && $ctype == 'int') ) {
                  $statement = 1;
                  $str.= "\n   SELECT CONCAT(name, ' (', username, ')') into oval FROM `".$prefix."users` WHERE OLD.".$col." != 0 AND id = OLD.".$col.";" ;
               }

               if ( $statement == 1 ) {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, old_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$ctype."', component, oval, 'DELETE', OLD.".$pkeycol.", OLD.".$aliascol.", changedby, NOW());";
               } else {
                  $str.= "\n     INSERT INTO ".$ctable;
                  $str.= "\n        (table_name, column_name, column_type, component, old_value, action, row_key, row_key_link, change_by, change_date)";
                  $str.= "\n     VALUES ('".$tname."', '".$col."', '".$ctype."', component, OLD.".$col.", 'DELETE', OLD.".$pkeycol.", OLD.".$aliascol.", changedby, NOW());";
               }
            } else {
               $str.= "\n     INSERT INTO ".$ctable;
               $str.= "\n        (table_name, column_name, column_type, component, old_value, action, row_key, row_key_link, change_by, change_date)";
               $str.= "\n     VALUES ('".$tname."', '".$col."', '".$ctype."', component, OLD.".$col.", 'DELETE', OLD.".$pkeycol.", OLD.".$aliascol.", changedby, NOW());";
            }
            $str.= "\n   END IF;";
         }
      }
      return $str;
   }

   static function trans_state($type)
   {
      $str = NULL;

      if ( $type == 'U' || $type == 'I' ) {
         $str.= "\n   IF (NEW.state is not null) THEN";
         $str.= "\n      CASE NEW.state";
         $str.= "\n         WHEN  0 THEN SET nval = '".JText::_('JUNPUBLISHED')."';";
         $str.= "\n         WHEN  1 THEN SET nval = '".JText::_('JPUBLISHED')."';";
         $str.= "\n         WHEN -1 THEN SET nval = '".JText::_('JARCHIVED')."';";
         $str.= "\n         WHEN -2 THEN SET nval = '".JText::_('JTRASHED')."';";
         $str.= "\n      END CASE;";
         $str.= "\n   END IF;";
      }

      if ( $type == 'U' || $type == 'D' ) {
         $str.= "\n   IF (OLD.state is not null) THEN";
         $str.= "\n      CASE OLD.state";
         $str.= "\n         WHEN  0 THEN SET oval = '".JText::_('JUNPUBLISHED')."';";
         $str.= "\n         WHEN  1 THEN SET oval = '".JText::_('JPUBLISHED')."';";
         $str.= "\n         WHEN -1 THEN SET oval = '".JText::_('JARCHIVED')."';";
         $str.= "\n         WHEN -2 THEN SET oval = '".JText::_('JTRASHED')."';";
         $str.= "\n      END CASE;";
         $str.= "\n   END IF;";
      }

      return $str;
   }

/*
      function update_type_comparison ($dtype = 'int', $tname, $fname, $ctable, $rkey, $pkey, $changeby)
      {
         $query = "";
         switch ($dtype) {
            case "varchar":
            case "char":
            case "text":
            case "mediumtext":
            case "longtext":
            case "tinytext":
            case "blob":
            case "mediumblob":
            case "longblob":
               echo "data type should be treated as text";
               break;
            case "bigint":
            case "mediumtext":
            case "tinyint":
            case "int":
            case "set":
            case "decimal":
            case "double":
            case "float":
               echo "datatype should be treated as integers";
               break;
            case "datetime":
            case "date":
            case "time":
            case "timestamp":
               echo "datatype should be treated as dates";
               break;
            case "enum":
               // Cast to a string and compare the strings!
               echo "datatype should be cast to a string and compared";
               break;
            default:
               echo "Undefined type determined.";
         }
         return $query;
      }
*/

   /*
    * Method to remove a trigger.
    *
    */
   public static function rem_trigger ($trig)
   {
      $db = JFactory::getDBO();

      $query= "DROP TRIGGER IF EXISTS `".$trig."`";
      $db->setQuery($query);
      $db->execute();
   }

  /*
    * Create the trigger in the database.
    *
    */
   static function applyTrigger( $data )
   {
      $db = JFactory::getDBO();
      $query = strip_tags($data['trigger_text']);
      if (empty($query) ) {
         $app = JFactory::getApplication();
         $app->enqueueMessage(JText::_('COM_JAUDIT_NO_TRIGGERTEXT_MSG'), 'error');
      }

      $trig = $data['trigger_name'];
      $db->setQuery("DROP TRIGGER IF EXISTS `".$trig."`");
      $db->execute();

      $db->setQuery($query);
      $db->execute();
   }

}